//************************************************
//*  OMR Interface DLL 32 Bits functions         *
//*  Library Version 2.0                         *
//*  Copyright 2009 - 2019 All rigths reserved   *
//*  RECOGNIFORM TECHNOLGIES SPA                 *
//*  www.recogniform.com - info@recogniform.com  *
//************************************************
import com.sun.jna.Library;
import com.sun.jna.Memory;
import com.sun.jna.Native;


public interface RecoOMRAPI extends Library {
	RecoOMRAPI INSTANCE = (RecoOMRAPI) Native.loadLibrary("recoomr" ,RecoOMRAPI.class);
	
	//  Goal: initialize the engine
	//  Requires: company name, license string
	//  Result: session handle
	public int OMR_Init(String User, String Password);
	
	//  Goal: recognize a check box
	//  Requires: session handle, dib handle, mark coordinates
	//  Result: success or error
	public int OMR_Recognize(int SessionHandle, int DIBHandle, int Left, int Top, int Right, int Bottom);
	
	//  Goal: the size of mark in percentage respect to the box diagonal size
	//  Requires: session handle
	//  Result: success or error, the size of mark in percentage
	public int OMR_GetMarkDensityPercent(int SessionHandle, Memory Value);
	
	//  Goal: the size of mark in percentage respect to the box diagonal size
    //  Requires: session handle
    //  Result: success or error, the size of mark in percentage
	public int OMR_GetMarkSizePercent(int SessionHandle, Memory Value);
	
	//  Goal: deinitialize the engine
    //  Requires: session handle
    //  Result: n/a
	public void OMR_Done(int SessionHandle);
	
	//  Goal: import a DDB building an DIB handle.
    //  Requires: session handle, PaletteHandle
    //  Result: BitmapHandle
	public int OMR_ImportDDB(int SessionHandle,int BitmapHandle,int PaletteHandle);
	
	//  Goal: load an image from file getting a DIB handle
    //  Requires: session handle, file name
    //  Result: the dib handle
	public int OMR_LoadImage(int SessionHandle, String FileName);
	
	//  Goal: free from memory an image previously loaded
    //  Requires: session handle, DIB handle
    //  Result: n/a
	public void OMR_FreeImage(int SessionHandle,int DIBHandle);
	
	//  Goal: recognize if there is a signature on a part of document
    //  Requires: session handle, DIB handle
    //  Result: success or error, signature coordinates, stroke length, signature pixel of located printed character, number of the pixel of recognized horizontal line, noise in pixel
	public int OMR_RecognizeSignature(int SessionHandle, int DIBHandle, Memory SignatureLeft, Memory SignatureTop, Memory SignatureRight, Memory SignatureBottom, Memory SignatureStrokeLengthPixel, Memory SignatureStrokeAreaPixel, Memory SignaturePrePrintedCharactersCount, Memory SignaturePrePrintedLinePixel , Memory SingatureNoisePixel);
	
	
	
}
